<?php 

include ("../set_session.php");
session_start(); 
include ("../settings.php");
include ("../language/$cfg_language");
$lang=new language();

if($cfg_barcodemode=='checked')
{

	include ("../classes/db_functions.php");
	include ("../classes/security_functions.php");		
	include ("../classes/display.php");
	
	$dbf=new db_functions($cfg_server,$cfg_username,$cfg_password,$cfg_database,$cfg_tableprefix,$cfg_theme,$lang);
	$sec=new security_functions($dbf,'Sales Clerk',$lang);
	$display=new display($dbf->conn,$cfg_theme,$cfg_currency_symbol,$lang);
	$cf=new Codefilter();

	if(isset($_POST['customer']))
	{
		if($dbf->isValidCustomer($_POST['customer']))
		{
			$_SESSION['current_sale_customer_id']=$_POST['customer'];
		}
	}

	if(isset($_POST['locker']))
	{
		if($dbf->isValidlocker($_POST['locker']) && $dbf->isLockerUsed($_POST['locker']))
		{
			$_SESSION['current_sale_customer_id']=$dbf->lockertocustomer_id($_POST['locker']);
		}
	}

	$table_bg=$display->sale_bg;
	$items_table="$cfg_tableprefix".'items';

	if(!$sec->isLoggedIn())
	{
		header ("location: ../login.php");
		exit();
	}

	?>

	<html>
	<head>
	<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=<?php echo $lang->CharCode?>">
	<script type="text/javascript" language="javascript">
	<!--
	function customerFocus()
	{
		document.scan_customer.customer.focus();
	}
	
	function itemFocus()
	{
		document.scan_item.item.focus();
	}

	function lockerFocus()
	{
		document.scan_locker.locker.focus();
	}
	
	function check_endSale()
	{
		if(document.scan_item.item.value==0){
			document.add_sale.submit();
			return false;
		} else {
			return True;
		}
	}
	//-->
	</script>
	
	</head>
	
	<?php
	if(isset($_SESSION['current_sale_customer_id']))
	{
	?>
	<body onLoad="itemFocus();">
	<?php
	}
	else
	{
	?>
	<body onLoad="lockerFocus();">
	<?php
	//<body onLoad="customerFocus();">
	}




	$display->displayTitle("$lang->newSaleBarcode");

	//customer number
	if(empty($_SESSION['current_sale_customer_id']))
	{
		echo "<center><small>($lang->scanInCustomer)</small>";
		echo "<center><form name='scan_customer' action='sale_ui.php' method='POST'>
		$lang->customerID: <input type='text' name='customer' size='6' style='ime-mode: disabled;'>
		<input type='submit'></form>";
	}

	//locker number
	if(empty($_SESSION['current_sale_customer_id']))
	{
		echo "<form name='scan_locker' action='sale_ui.php' method='POST'>
		$lang->lockernum: <input type='text' name='locker' size='6' style='ime-mode: disabled;'>
		<input type='submit' value=$lang->submit></form>";
	}

	if(isset($_SESSION['current_sale_customer_id']))
	{
	
	
		if(isset($_POST['item']))
		{
			if($dbf->isValidItem($_POST['item']))
			{
				$_SESSION['items_in_sale'][]=$_POST['item'].' '.'1';
			}
		}
		
		if(isset($_SESSION['items_in_sale']))
		{
			$num_items=count($_SESSION['items_in_sale']);
	
		}
		else
		{
			$num_items=0;
		}	
		$temp_item_name='';
		$temp_item_id='';
		$temp_quantity='';
		$temp_price='';
		$item_info=array();
	
		$customers_table="$cfg_tableprefix".'customers';
		$order_customer_first_name=$dbf->idToField($customers_table,'first_name',$_SESSION['current_sale_customer_id']);
		$order_customer_last_name=$dbf->idToField($customers_table,'last_name',$_SESSION['current_sale_customer_id']);
		$order_customer_name=$order_customer_last_name.' '.$order_customer_first_name;
	
		echo "<hr><center><a href=delete.php?action=all>[$lang->clearSale]</a><br><br>";
		
		
		echo "<center><small>($lang->scanInItem)</small><form name='scan_item' action='sale_ui.php' method='POST' onsubmit='return check_endSale();'>
		$lang->itemID: <input type='text' name='item' size='6' style='ime-mode: disabled;'>
		<input type='submit'></form>";
		
		
		
		echo "<h3>$lang->shoppingCart</h3>
		
		<form name='add_sale' action='addsale.php' method='POST'>
		$lang->orderFor: <b>$order_customer_name</b><br>";
		echo "<table border='0' bgcolor='$table_bg' cellspacing='0' cellpadding='2'>
		<tr><th><font color=CCCCCC>$lang->remove</font></th>
		<th><font color=CCCCCC>$lang->itemName</font></th>
		<th><font color=CCCCCC>$lang->unitPrice</font></th>
		<th><font color=CCCCCC>$lang->tax %</font></th>
		<th><font color=CCCCCC>$lang->quantity</font></th></tr>
		";

		for($k=0;$k<$num_items;$k++)
		{
			$item_info=explode(' ',$_SESSION['items_in_sale'][$k]);
			$temp_item_id=$item_info[0];
			$temp_item_name=$dbf->idToField($items_table,'item_name',$temp_item_id);
			$temp_price=$dbf->idToField($items_table,'unit_price',$temp_item_id);
			$temp_tax=$dbf->idToField($items_table,'tax_percent',$temp_item_id);
			$temp_quantity=$item_info[1];

		
		
			echo "<tr><td align='center'><a href=delete.php?action=item&pos=$k><font color=white>[$lang->delete]</font></a></td>
					  <td align='center'><font color='white'><b>$temp_item_name</b></font></td>
					  <td align='center'><input type=text name='price$k' value='$temp_price' size='8' style='ime-mode: disabled;'></td>
					  <td align='center'><input type=text name='tax$k' value='$temp_tax' size='3' style='ime-mode: disabled;'></td>
					  <td align='center'><input type=text name='quantity$k' value='$temp_quantity' size='3' style='ime-mode: disabled;'></td>
					  <input type='hidden' name='item_id$k' value='$temp_item_id'>
					  </tr>";
		}
	
	
		echo "</table><input type='hidden' name='num_items' value='$num_items'>
		<input type='hidden' name='customer_name' value='$order_customer_name'>";
	
	
		echo "<br><table border='0' bgcolor='$table_bg'>
		<tr>
		<td>
		<font color='white'>$lang->paidWith:</font> 
		</td>
		<td>
		<select name='paid_with'>
		<option value='$lang->cash'>$lang->cash</option>
		<option value='$lang->check'>$lang->check</option>
		<option value='$lang->credit'>$lang->credit</option>
		<option value='$lang->giftCertificate'>$lang->giftCertificate</option>
		<option value='$lang->account'>$lang->account</option>
		<option value='$lang->other'>$lang->other</option>
		</select></td>
		</tr>
		<tr>
		<td>
		<font color='white'>$lang->saleComment:</font>
		</td>
		<td>
		<input type=text name=comment size=25 style='ime-mode: active;'>
		</td>
		</tr>
		</table>
    	  <br>
		  <input type=hidden name='pre_sale_total' value='*'>
    	  <input type='submit' value='Add Sale'></center></form>";		
	}

	


}
else//Start non barcode UI
{
?>
	<html>
	<head>
	<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=<?php echo $lang->CharCode?>">
	</head>

<body>

<?php
include ("../classes/db_functions.php");
include ("../classes/security_functions.php");
include ("../classes/display.php");


$dbf=new db_functions($cfg_server,$cfg_username,$cfg_password,$cfg_database,$cfg_tableprefix,$cfg_theme,$lang);
$sec=new security_functions($dbf,'Sales Clerk',$lang);
$display=new display($dbf->conn,$cfg_theme,$cfg_currency_symbol,$lang);
$cf=new Codefilter();

$table_bg=$display->sale_bg;
$items_table="$cfg_tableprefix".'items';

if(!$sec->isLoggedIn())
{
	header ("location: ../login.php");
	exit();
}

	if(isset($_POST['addToCart']))
	{
			
		if(empty($_POST['items']))
		{
			echo "<b>$lang->youMustSelectAtLeastOneItem</b><br>";
			echo "<a href=javascript:history.go()>$lang->refreshAndTryAgain</a>";
			exit();
	
		}
	
		if(isset($_POST['customer']))
		{
			$_SESSION['current_sale_customer_id']=$_POST['customer'];
		}
		elseif(empty($_SESSION['current_sale_customer_id']))
		{
			echo "<b>$lang->mustSelectCustomer</b><br>";
			echo "<a href=javascript:history.go()>$lang->refreshAndTryAgain</a>";
			exit();
		}
	
		$items_to_add=array();
		$items_to_add=$_POST['items'];
		$quantity_to_add=$_POST['quantity'];
	
		for($k=0;$k<count($items_to_add);$k++)
		{
			$_SESSION['items_in_sale'][]=$items_to_add[$k].' '.$quantity_to_add;
		
		}
	
	
	}	
	
	$display->displayTitle("$lang->newSale");
	echo "<center><form name='additem' method='POST' action='sale_ui.php'>	 
		 <table border=0 cellspacing='0' cellpadding='2' bgcolor='$table_bg'>";
		 
		 	if(empty($_SESSION['current_sale_customer_id']))
		 	{
				 $customers_table="$cfg_tableprefix".'customers';
				 	 		
				 if(isset($_POST['customer_search']) and $_POST['customer_search']!='')
				 {
				 	$search=$_POST['customer_search'];
					$_SESSION['current_customer_search']=$search;
					$search_euc = $cf->PutDB($search);
				 	$customer_result=mysql_query("SELECT first_name,last_name,id FROM $customers_table WHERE last_name like \"%$search_euc%\" or first_name like \"%$search_euc%\" or id =\"$search_euc\" ORDER by last_name",$dbf->conn) or die(mysql_error());//
			     }
				 elseif(isset($_SESSION['current_customer_search']))
				 {
				 	$search=$_SESSION['current_customer_search'];
					$search_euc = $cf->PutDB($search);
				 	$customer_result=mysql_query("SELECT first_name,last_name,id FROM $customers_table WHERE last_name like \"%$search_euc%\" or first_name like \"%$search_euc%\" or id =\"$search_euc\" ORDER by last_name",$dbf->conn) or die(mysql_error());//

				 }
				 elseif($dbf->getNumRows($customers_table) >200)
				 {
				 	$customer_result=mysql_query("SELECT first_name,last_name,id FROM $customers_table ORDER by last_name LIMIT 0,200",$dbf->conn) or die(mysql_error());//	
				 }
				 else
				 {
				 	 $customer_result=mysql_query("SELECT first_name,last_name,id FROM $customers_table ORDER by last_name",$dbf->conn) or die(mysql_error());//
				 }
		 		
			 		$customer_title=isset($_SESSION['current_customer_search']) ? "<b><font color=white>$lang->selectCustomer:</font></b>":"<font color=white>$lang->selectCustomer:</font>";
					echo "<tr><td colspan='3'>$customer_title
		 			<select name='customer'>";
	 		
	 			
	 		
				 while($row=mysql_fetch_assoc($customer_result))
				 {
				 	$id=$row['id'];
				 	$display_name=$cf->GetDB($row['last_name'].' '.$row['first_name']);
				 	echo "<option value=$id>$display_name</option>";
				 }
				echo "</select></td>
				
				<td><font color=white>$lang->findCustomer:</font> 
				<input type='text' size='8' name='customer_search'>
				<input type='submit' value='Go'> <a href='delete.php?action=customer_search'><font size='-1' color='white'>[$lang->clearSearch]</font></a></td></tr>";
			}

		  $items_table="$cfg_tableprefix".'items';
		  $brands_table="$cfg_tableprefix".'brands';
	  
	  
		  if(isset($_POST['item_search'])  and $_POST['item_search']!='')
		  {
		  	$search=$_POST['item_search'];
		  	$_SESSION['current_item_search']=$search;
			$search_euc = $cf->PutDB($search);
		  	$item_result=mysql_query("SELECT item_name,unit_price,tax_percent,brand_id,id FROM $items_table WHERE item_name like \"%$search_euc%\" or item_number= \"$search_euc\" or id =\"$search_euc\" ORDER by item_name",$dbf->conn) or die(mysql_error());//
		  }
		  elseif(isset($_SESSION['current_item_search']))
		  {
		  	$search=$_SESSION['current_item_search'];
			$search_euc = $cf->PutDB($search);
		  	$item_result=mysql_query("SELECT item_name,unit_price,tax_percent,brand_id,id FROM $items_table WHERE item_name like \"%$search_euc%\" or item_number= \"$search_euc\" or id =\"$search_euc\" ORDER by item_name",$dbf->conn) or die(mysql_error());//
	
		  }
		  elseif($dbf->getNumRows($items_table) >200)
		  {
		  	$item_result=mysql_query("SELECT item_name,unit_price,tax_percent,brand_id,id FROM $items_table ORDER by item_name LIMIT 0,200",$dbf->conn) or die(mysql_error());//
		  }
		  else
		  {
		  	$item_result=mysql_query("SELECT item_name,unit_price,tax_percent,brand_id,id FROM $items_table ORDER by item_name",$dbf->conn) or die(mysql_error());//
		  }
		  		
	  
			$item_title=isset($_SESSION['current_item_search']) ? "<b><font color=white>$lang->selectItem</font></b>":"<font color=white>$lang->selectItem</font>";
		    echo "<tr>
			
			<td colspan='4' align='left'><font color=white>$lang->findItem:</font>
			<input type='text' size='8' name='item_search'>
			<input type='submit' value='Go' tabindex='3'> <a href='delete.php?action=item_search'><font size='-1' color='white'>[$lang->clearSearch]</font></a></td></tr>";
	
			
			
				echo "<tr><td colspan='4' align='center'>$item_title</td></tr>
				<tr><td align='center' colspan='4'>
					<select name='items[]' multiple size='8'>\n";
	 
		  while($row=mysql_fetch_assoc($item_result))
		  {
		  	$id=$row['id'];
		  	$brand_id=$row['brand_id'];
		  	$brand_name=$dbf->idToField("$brands_table",'brand',"$brand_id");
		    $display_item="$brand_name".'- '.$cf->GetDB($row['item_name']);
		 	echo "<option value=$id>$display_item</option>\n";
	  
		  }
	echo "</select></td></tr></center>

	<tr><td align='center' colspan='4'><font color=white>$lang->quantity:</font> <input type='text' size='4' name='quantity' value='1'>
	<input type='submit' value='Add To Cart' name=addToCart tabindex='1'></td></tr></table></form>";	 

	if(empty($_SESSION['items_in_sale']))
	{
		echo "<center><h3>$lang->yourShoppingCartIsEmpty</h3></center>";
	}
	if(isset($_SESSION['items_in_sale']))
	{
		$num_items=count($_SESSION['items_in_sale']);
		$temp_item_name='';
		$temp_item_id='';
		$temp_quantity='';
		$temp_price='';
		$item_info=array();
		
		$customers_table="$cfg_tableprefix".'customers';
		$order_customer_first_name=$dbf->idToField($customers_table,'first_name',$_SESSION['current_sale_customer_id']);
		$order_customer_last_name=$dbf->idToField($customers_table,'last_name',$_SESSION['current_sale_customer_id']);
		$order_customer_name=$order_customer_last_name.' '.$order_customer_first_name;
		
		echo "<hr><center><a href=delete.php?action=all>[Clear Sale]</a><h3>$lang->shoppingCart</h3><form name='add_sale' action='addsale.php' method='POST'>
		$lang->orderFor: <b>$order_customer_name</b><br>";
		echo "<table border='0' bgcolor='$table_bg' cellspacing='0' cellpadding='2'>
		<tr><th><font color=CCCCCC>$lang->remove</font></th>
		<th><font color=CCCCCC>$lang->itemName</font></th>
		<th><font color=CCCCCC>$lang->unitPrice</font></th>
		<th><font color=CCCCCC>$lang->tax %</font></th>
		<th><font color=CCCCCC>$lang->quantity</font></th></tr>
		";
		
		for($k=0;$k<$num_items;$k++)
		{
			$item_info=explode(' ',$_SESSION['items_in_sale'][$k]);
			$temp_item_id=$item_info[0];
			$temp_item_name=$dbf->idToField($items_table,'item_name',$temp_item_id);
			$temp_price=$dbf->idToField($items_table,'unit_price',$temp_item_id);
			$temp_tax=$dbf->idToField($items_table,'tax_percent',$temp_item_id);
			$temp_quantity=$item_info[1];

		
		
			echo "<tr><td align='center'><a href=delete.php?action=item&pos=$k><font color=white>[$lang->delete]</font></a></td>
					  <td align='center'><font color='white'><b>$temp_item_name</b></font></td>
					  <td align='center'><input type=text name='price$k' value='$temp_price' size='8'></td>
					  <td align='center'><input type=text name='tax$k' value='$temp_tax' size='3'></td>
					  <td align='center'><input type=text name='quantity$k' value='$temp_quantity' size='3'></td>
					  <input type='hidden' name='item_id$k' value='$temp_item_id'>
					  </tr>";
		}
	
	
		echo "</table><input type='hidden' name='num_items' value='$num_items'>
		<input type='hidden' name='customer_name' value='$order_customer_name'>";
		
		
		echo "<br><table border='0' bgcolor='$table_bg'>
		<tr>
		<td>
		<font color='white'>$lang->paidWith:</font> 
		</td>
		<td>
		<select name='paid_with'>
		<option value='$lang->cash'>$lang->cash</option>
		<option value='$lang->check'>$lang->check</option>
		<option value='$lang->credit'>$lang->credit</option>
		<option value='$lang->giftCertificate'>$lang->giftCertificate</option>
		<option value='$lang->account'>$lang->account</option>
		<option value='$lang->other'>$lang->other</option>
		</select></td>
		</tr>
		<tr>
		<td>
		<font color='white'>$lang->saleComment:</font>
		</td>
		<td>
		<input type=text name=comment size=25>
		</td>
		</tr>
	
		</table>
    	  <br>
    	  <input type=hidden name='pre_sale_total' value='*'>
    	  <input type='submit' value='Add Sale'></center></form>";		
	}


}	  
$dbf->closeDBlink();


?>
</body>
</html>